<?php

/**
 * @file
 * Views integration for the Brilliant Gallery source table.
 *
 * @see http://drupal.org/project/views
 */

/**
 * Implements hook_views_data()
 */
function brilliant_gallery_views_data() {
  $data = array();

  $data['brilliant_gallery_sources'] = array(
    'table' => array(
      'base' => array(
        'field' => 'bgid',
        'title' => t('Brilliant Gallery Sources'),
        'help' => t('Brilliant Gallery module table reflecting all images in the main gallery folder.'),
      ),
      'group' => 'Brilliant Gallery',
    ),
    'bgid' => array(
      'title' => 'BGID',
      'help' => t('Brilliant Gallery IDs'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => FALSE,
      ),
    ),
    'path' => array(
      'title' => 'Path',
      'help' => t('Path'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
    ),
    'filename' => array(
      'title' => 'Filename',
      'help' => t('File name'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
    ),
    'hidden' => array(
      'title' => 'Hidden',
      'help' => t('Flag indicating whether the file is supposed to be hidden from view (Picasa; file .picasa.ini must be in the folder)'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
    ),
  );

  /*
  $data['brilliant_gallery_storage']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );
  */

  return $data;
}
